/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VCoreElementHierarchyRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreElementHierarchy extends TableImpl<VCoreElementHierarchyRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_element_hierarchy</code>
     */
    public static final VCoreElementHierarchy V_CORE_ELEMENT_HIERARCHY = new VCoreElementHierarchy();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreElementHierarchyRecord> getRecordType() {
        return VCoreElementHierarchyRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_element_hierarchy.key_element</code>.
     */
    public final TableField<VCoreElementHierarchyRecord, Integer> KEY_ELEMENT = createField(DSL.name("key_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column
     * <code>common_dd.v_core_element_hierarchy.key_element_type</code>.
     */
    public final TableField<VCoreElementHierarchyRecord, Integer> KEY_ELEMENT_TYPE = createField(DSL.name("key_element_type"), SQLDataType.INTEGER, this, "");

    /**
     * The column
     * <code>common_dd.v_core_element_hierarchy.key_parent_element</code>.
     */
    public final TableField<VCoreElementHierarchyRecord, Integer> KEY_PARENT_ELEMENT = createField(DSL.name("key_parent_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column
     * <code>common_dd.v_core_element_hierarchy.child_elements</code>.
     */
    public final TableField<VCoreElementHierarchyRecord, Long> CHILD_ELEMENTS = createField(DSL.name("child_elements"), SQLDataType.BIGINT, this, "");

    /**
     * The column <code>common_dd.v_core_element_hierarchy.child_vars</code>.
     */
    public final TableField<VCoreElementHierarchyRecord, Long> CHILD_VARS = createField(DSL.name("child_vars"), SQLDataType.BIGINT, this, "");

    /**
     * The column <code>common_dd.v_core_element_hierarchy.dn</code>.
     */
    public final TableField<VCoreElementHierarchyRecord, String> DN = createField(DSL.name("dn"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_element_hierarchy.order_nr</code>.
     */
    public final TableField<VCoreElementHierarchyRecord, Integer> ORDER_NR = createField(DSL.name("order_nr"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_element_hierarchy.short_name</code>.
     */
    public final TableField<VCoreElementHierarchyRecord, String> SHORT_NAME = createField(DSL.name("short_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_element_hierarchy.is_public</code>.
     */
    public final TableField<VCoreElementHierarchyRecord, Integer> IS_PUBLIC = createField(DSL.name("is_public"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_element_hierarchy.hier_lang</code>.
     */
    public final TableField<VCoreElementHierarchyRecord, String> HIER_LANG = createField(DSL.name("hier_lang"), SQLDataType.CLOB, this, "");

    private VCoreElementHierarchy(Name alias, Table<VCoreElementHierarchyRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreElementHierarchy(Name alias, Table<VCoreElementHierarchyRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_element_hierarchy" as  SELECT f.key_element,
          f.key_element_type,
          f.key_parent_element,
          COALESCE(co.sub_elements, (0)::bigint) AS child_elements,
          COALESCE(ch.amount, (0)::bigint) AS child_vars,
          f.dn,
          f.order_nr,
          f.short_name,
          f.is_public,
          f.hier_lang
         FROM ((common_dd.t_core_element_hierarchy f
           LEFT JOIN common_dd.v_core_element_hierarchy_count co ON ((f.key_element = co.key_parent_element)))
           LEFT JOIN common_dd.v_core_element_hierarchy_vars ch ON ((f.key_element = ch.key_parent_element)))
        WHERE (NOT (f.key_element IN ( SELECT t_core_variable.key_variable
                 FROM common_dd.t_core_variable)));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_element_hierarchy</code> table
     * reference
     */
    public VCoreElementHierarchy(String alias) {
        this(DSL.name(alias), V_CORE_ELEMENT_HIERARCHY);
    }

    /**
     * Create an aliased <code>common_dd.v_core_element_hierarchy</code> table
     * reference
     */
    public VCoreElementHierarchy(Name alias) {
        this(alias, V_CORE_ELEMENT_HIERARCHY);
    }

    /**
     * Create a <code>common_dd.v_core_element_hierarchy</code> table reference
     */
    public VCoreElementHierarchy() {
        this(DSL.name("v_core_element_hierarchy"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreElementHierarchy as(String alias) {
        return new VCoreElementHierarchy(DSL.name(alias), this);
    }

    @Override
    public VCoreElementHierarchy as(Name alias) {
        return new VCoreElementHierarchy(alias, this);
    }

    @Override
    public VCoreElementHierarchy as(Table<?> alias) {
        return new VCoreElementHierarchy(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreElementHierarchy rename(String name) {
        return new VCoreElementHierarchy(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreElementHierarchy rename(Name name) {
        return new VCoreElementHierarchy(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreElementHierarchy rename(Table<?> name) {
        return new VCoreElementHierarchy(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreElementHierarchy where(Condition condition) {
        return new VCoreElementHierarchy(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreElementHierarchy where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreElementHierarchy where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreElementHierarchy where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreElementHierarchy where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreElementHierarchy where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreElementHierarchy where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreElementHierarchy where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreElementHierarchy whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreElementHierarchy whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
